Page MenuHome

[Edit Mesh] overlay of linked meshes in Edit Mode. [2.82 regression]
Closed, ResolvedPublicBUG

Description

System Information
Operating system: Windows-10-10.0.17763-SP0 64 Bits
Graphics card: GeForce GTX 1060 6GB/PCIe/SSE2 NVIDIA Corporation 4.5.0 NVIDIA 430.86

Blender Version
Broken: version: 2.82 (sub 6), branch: master, commit date: 2020-01-12 16:23, hash: rB0ef881cc5782
Worked: (optional)

Short description of error
References in Edit Mode don't show selected\deselected vertices\edges on each over (like in previouse versions (2.8, 2.81a))
Is this bug or maybe feature? If it is feature, do you be so pleasure to help found it on interface or hotkey? It hard to work without it. I had to downgrade to 2.81a, and work without cool 2.82's features.

Exact steps for others to reproduce the error

  • select object
  • make some duplicate linked (alt+D or from menu)
  • enter on "Edit Mode
  • look on references - you don't see any selected vertices\edges\faces (like in 2.8 or 2.81)
  • try to change something- loop cut on example
  • exit to "Object Mode" - you'll see all new edges (if get an wireframe on shaded)
  • try to enter "Edit Mode" again - all edges in "wireframe on shaded mode" dissapeared!


Event Timeline

Oleksandr Kahal (ignietferro) renamed this task from [References] References in Edit Mode to [References] References in Edit Mode. 2.82.Jan 13 2020, 6:16 PM
ronsn added a subscriber: ronsn.Jan 13 2020, 7:40 PM

This behavior was introduced by this Git commit 07a959067d5a3c05fcbd65105525d6e139be5c5f (rB07a959067d5a).

So it means it would be? And references now couldn't be exactly as in previous versions? Or it is going to resolve in the future? Maybe I didn't understand something... I'm not coder, I'm 3D artist.

ronsn added a comment.Jan 13 2020, 8:40 PM

@Oleksandr Kahal (ignietferro): As far as I can see it was not intended to let it behave like this, but it is also likely that this behavior is a result of a necessary change to prevent Blender to crash in some situations like this one: https://developer.blender.org/T72848

However: My comment with that weird string wasn't addressed to you personally but for other developers to investigate this issue faster (if and when someone has time to investigate). :)

@ronsn Big thanks for explanation! I'll be waiting for resolvation of that issue.

Germano Cavalcante (mano-wii) changed the task status from Needs Triage to Confirmed.Jan 14 2020, 5:50 PM
Germano Cavalcante (mano-wii) triaged this task as High priority.
Germano Cavalcante (mano-wii) changed the subtype of this task from "Report" to "Bug".

I can confirm that rB07a959067d5a introduced the problem.
@Campbell Barton (campbellbarton), mind taking a look?

Germano Cavalcante (mano-wii) renamed this task from [References] References in Edit Mode. 2.82 to [Edit Mesh] overlay of linked meshes in Edit Mode. [2.82 regression].Jan 14 2020, 5:52 PM

I think i've tracked it down to this line in overlay_engine.c:

188   const bool in_edit_mode = (ob->mode & OB_MODE_EDIT) && BKE_object_is_in_editmode(ob);

As stated by @ronsn and @Germano Cavalcante (mano-wii) it was introduced in rB07a959067d5a,
so simply changing it back to

188   const bool in_edit_mode = BKE_object_is_in_editmode(ob);

will resolve the issue.
However, testing https://developer.blender.org/T72848 causes a segfault.

Tagging with 2.82 since this was marked as high priority and is a regression.

Issue wasn't assigned. Will check on it upcoming week.

Seems like that b281 and b280 drew all the object as they were in edit mode, but the selection engine didn't react to the duplicates as these objects were not in edit mode. Personally I find the functionality a bit weird but this was also the case for b279 so will add a patch.

Note that I wasn't able to let it crash as mentioned by @Marten Homma (martenmh). This could be that other changes (like T72490: Collections: Exclude From View toggle causes segment violation.) fixed the crash.
Could other people help out testing the patch provided by @Marten Homma (martenmh).

I am not able to reproduce the issue that @Campbell Barton (campbellbarton) mentions in the patch. In a discussion on blender.chat we identified that this functionality has differences between blender versions and has limitations when used in different ways (modifiers + multi object editing selection to name some)

Render with modifiers

  • 2.79: Does not render the edit overlay when one object has a modifier (visible or not)

  • 2.80+2.81: Does render the edit overlay event when modifiers are added, resulting in incorrect geometry

  • 2.82: Does not render the edit overlay at all

  • 2.82 + this patch: renders like 2.80 or 2.81, but it has been reported that it crashes when adding/removing modifiers

Render without modifiers

  • 2.79 will render the edit overlay on all duplicates

  • 2.80+2.81 will render the editor overlay on all duplicates

  • 2.82 will not render the edit overlay

  • 2.82 + this patch: renders like 2.80 or 2.81.

Other issues

  • Multi object editing of linked duplicated meshes: Selection does not work, except for the active object

In the manual a overview is given https://docs.blender.org/manual/en/latest/scene_layout/object/editing/duplication.html#linked-duplicates but does not go into the details. What makes it valid to apply the patch with the addition to check for active modifiers. This option has there been for a long time but hasn't have good documentation, therefore can failed when used differently.

My biggest concern is that it has been reported that the change crashes when used in a certain way.